VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.2#0"; "COMCTL32.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   3615
   ClientLeft      =   45
   ClientTop       =   615
   ClientWidth     =   7410
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3615
   ScaleWidth      =   7410
   StartUpPosition =   1  'CenterOwner
   Begin ComctlLib.StatusBar StatusBar1 
      Align           =   2  'Align Bottom
      Height          =   495
      Left            =   0
      TabIndex        =   6
      Top             =   3120
      Width           =   7410
      _ExtentX        =   13070
      _ExtentY        =   873
      SimpleText      =   ""
      _Version        =   327682
      BeginProperty Panels {0713E89E-850A-101B-AFC0-4210102A8DA7} 
         NumPanels       =   1
         BeginProperty Panel1 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            Key             =   ""
            Object.Tag             =   ""
         EndProperty
      EndProperty
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   2760
      Top             =   1080
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327681
   End
   Begin VB.CommandButton Command5 
      Caption         =   "Stop Log"
      Height          =   855
      Left            =   6120
      TabIndex        =   5
      Top             =   2040
      Width           =   1095
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Start Log"
      Height          =   855
      Left            =   4800
      TabIndex        =   4
      Top             =   2040
      Width           =   1095
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Group: 1000"
      Height          =   735
      Left            =   5520
      TabIndex        =   3
      Top             =   1080
      Width           =   975
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Exit"
      Height          =   855
      Left            =   6120
      TabIndex        =   2
      Top             =   0
      Width           =   1095
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Restart"
      Height          =   855
      Left            =   4800
      TabIndex        =   1
      Top             =   0
      Width           =   1095
   End
   Begin VB.Timer Timer1 
      Left            =   1920
      Top             =   1080
   End
   Begin VB.ListBox List1 
      Height          =   2985
      ItemData        =   "prime1.frx":0000
      Left            =   120
      List            =   "prime1.frx":0002
      TabIndex        =   0
      Top             =   0
      Width           =   4455
   End
   Begin VB.Menu mnuFile1 
      Caption         =   "File"
      Begin VB.Menu mnuStartlog1 
         Caption         =   "Startlog"
      End
      Begin VB.Menu mnuStoplog1 
         Caption         =   "Stoplog"
      End
      Begin VB.Menu mnuExit1 
         Caption         =   "Exit"
      End
   End
   Begin VB.Menu mnuAbout1 
      Caption         =   "About"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Rem Prime v1.0a for VB5 is PD 2002.
DefDbl A-Z ' declare all default variables.
Dim p() As Double ' define prime divissor array.
Dim u As Double ' define group counter.
Dim LogFilename As String ' store log filename.
Dim LogIsOn As Integer ' store log file status.

Private Sub Command1_Click()
 ' restart.
 List1.Clear
 Primes
End Sub

Private Sub Command2_Click()
 ' exit.
 mnuExit1_Click
End Sub

Private Sub Command3_Click()
 ' change group counter.
 Select Case u
 Case 1000
    u = 10000
 Case 10000
    u = 100000
 Case 100000
    u = 1000000
 Case 1000000
    u = 1000
 End Select
 Command3.Caption = "Group:" + Str$(u)
 List1.Clear
 Primes
End Sub

Private Sub Command4_Click()
 On Local Error GoTo errorroutine
 ' start log
 CommonDialog1.filename = "prime.log"
 CommonDialog1.Filter = "Log Files|*.log"
 CommonDialog1.ShowOpen
 LogFilename = CommonDialog1.filename
 If Len(LogFilename) Then
    If LCase$(Right$(LogFilename, 4)) = ".log" Then
       If LogIsOn Then
          Close #1
       End If
       LogIsOn = True
       StatusBar1.Panels(1).Text = "LOG ON"
       Open LogFilename For Append As #1
    End If
 End If
 Exit Sub
errorroutine:
 MsgBox ("Can't open log.")
 LogIsOn = False
 StatusBar1.Panels(1).Text = "LOG OFF"
 Resume Next
End Sub

Private Sub Command5_Click()
 ' stop log
 LogIsOn = False
 StatusBar1.Panels(1).Text = "LOG OFF"
End Sub

' first we load the primes which will be the divisors.
Private Sub Form_Load()
 j = 4096
 ReDim p(4096) As Double
 q = 0
 Z = 1
 Do
    Z = Z + 1
    f = 0
    For l = 2 To Int(Sqr(Z))
       If Z / l = Z \ l Then
          f = -1
          Exit For
       End If
    Next
    If f = 0 Then
       q = q + 1
       p(q) = Z
    End If
    If q = j Then
       Exit Do
    End If
    DoEvents
 Loop
 ' reset the log indicator.
 StatusBar1.Panels(1).Text = "LOG OFF"
 ' set the group counter.
 u = 1000
 ' list1 window start timer.
 Timer1.Interval = 100
End Sub

Private Sub Form_Unload(Cancel As Integer)
 If LogIsOn Then
    Close #1
 End If
 Erase p
 End
End Sub

Private Sub Primes()
   ' since the highest divisor we stored is the square of the highest prime,
   ' the tester knows the last prime which will be calculated.
   v = p(4096) * p(4096)
   A$ = "Last prime: " + Format$(v, "#,##0;;")
   List1.AddItem A$
   If LogIsOn Then
      Print #1, A$
   End If
   ' start timing.
   T! = Timer
   w = 1
   Z = 1
   l = 0
   Do
      Z = Z + 2
      q = 1
      f = 0
      Do
         ' divide by the primes in the array
         q = q + 1
         ' already tested all prime divisors up to the square, so it is prime.
         If p(q) > Int(Sqr(Z)) Then
            Exit Do
         End If
         ' an even divide is not a prime.
         If Z / p(q) = Z \ p(q) Then
            f = -1
            Exit Do
         End If
      Loop
      ' found a prime.
      If f = 0 Then
         w = w + 1
         ' check counted up to group.
         If w / u = w \ u Then
            o! = Timer - T!
            If o! < 0! Then
               o! = o! + 86400!
            End If
            ' log and display and scroll.
            A$ = "Prime " + Format$(w, "#,##0;;")
            A$ = A$ + " equals: " + Format$(Z, "#,##0;;")
            A$ = A$ + " --- " + Str$(o!) + " sec."
            List1.AddItem A$
            If LogIsOn Then
               Print #1, A$
            End If
            l = l + 1
            If l >= 15 Then
               l = 15
               List1.RemoveItem 0
            End If
         End If
      End If
      ' check the highest prime which can be tested.
      If Z > (p(4096) * p(4096)) Then
         Exit Do
      End If
      DoEvents
   Loop
End Sub

Private Sub List1_Click()
 ' restart list1 box.
 List1.Clear
 Primes
End Sub

Private Sub mnuAbout1_Click()
 ' about box.
 MsgBox ("Prime Number Generator PD 2002.")
End Sub

Private Sub mnuExit1_Click()
 Dim Response
 ' show exit dialog.
 Response = MsgBox("Are you sure?", vbQuestion + vbYesNoCancel, "Exit Dialog")
 If Response = vbYes Then
    Form_Unload (ret)
 End If
End Sub

Private Sub mnuStartlog1_Click()
 ' start log.
 Command4_Click
End Sub

Private Sub mnuStoplog1_Click()
 ' stop log.
 Command5_Click
End Sub

Private Sub Timer1_Timer()
 ' list1 start routine.
 Timer1.Enabled = False
 List1_Click
End Sub
